﻿
using System;
using System.Collections.Generic;
namespace HeuristicLab.Algorithms.GraphRouting.Utilities {
  public class PriorityQueueOld<P, T> where P : IComparable {
    SortedList<Pair<P>, T> list;
    P dummy;

    public PriorityQueueOld() {
      list = new SortedList<Pair<P>, T>(new PairComparer<P>());
    }

    public int Count {
      get { return list.Count; }
    }

    public void Enqueue(T item, P priority) {
      list.Add(new Pair<P>(priority, dummy), item);
      //count++;
    }

    public T Dequeue() {
      T item = list[list.Keys[0]];
      list.RemoveAt(0);
      return item;
    }

    public bool Contains(T item) {
      return list.ContainsValue(item);
    }

    public bool Remove(T item) {
      bool delete = false;
      KeyValuePair<Pair<P>, T> toDelete = new KeyValuePair<Pair<P>, T>();
      foreach (var pair in list) {
        if (pair.Value.Equals(item)) {
          delete = true;
          toDelete = pair;
        }
      }
      if (delete) {
        return list.Remove(toDelete.Key);
      }
      return false;
    }

  }
}
